#import "AuthenticateDelegate.h"
#import "BackpackAppDelegate.h"
#import <WebKit/WebKit.h>
#import "EMKeychainItem.h"

@implementation AuthenticateDelegate

- (id)init
{
    self = [super init];
    if (self) {
        // NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
        // NSDictionary *appDefaults = [NSDictionary dictionaryWithObject:@"empty" forKey:@"InstaToken"];
        
        // [defaults registerDefaults:appDefaults];
    }
    
    return self;
}

- (void)webView:(WebView *)sender didFinishLoadForFrame:(WebFrame *)frame {
    
    //NSLog(@"url: %@", @"Finished Loading");
    if (frame == [sender mainFrame]){
        
        // NSString *url = [[[[frame dataSource] request] URL] absoluteString];
        // NSLog(@"url is: %@", url);
        
        // LETS PARSE!
        NSURL *newURL = [[[frame dataSource] request] URL];
        NSString *token = [newURL fragment];
        // NSLog(@"fragment is: %@", token);
        
        NSArray *newAr = [token componentsSeparatedByString:@"="];
        NSString *realToken = [newAr objectAtIndex:1];
        
        if (token) {
            // NSLog(@"token is: %@", realToken);
            
            // SAVE TOKEN TO KEYCHAIN
            NSString *currentUser = NSUserName();
            [EMGenericKeychainItem addGenericKeychainItemForService:@"Photoplank" withUsername:currentUser password:realToken];
            
            // save to temptoken
            BackpackAppDelegate *appDelegate = (BackpackAppDelegate *)[[NSApplication sharedApplication] delegate];
            [appDelegate setTempUserToken:realToken];
            
            // SEND MESSAGE TO CLOSE AUTH WINDOW AND SHOW NEW UI
            [appDelegate openMainView];
        } else {
            // no token, not authenticated
        }
    }
}

- (void)dealloc
{
    [super dealloc];
}

@end
