#import "AuthenticateWindowController.h"
#import <WebKit/WebKit.h>
#import "AuthenticateDelegate.h"
#import "GTMOAuth2Authentication.h"
#import "GTMOAuth2SignIn.h"
#import "GTMOAuth2WindowController.h"

@implementation AuthenticateWindowController;
@synthesize web;

NSString *kClientID = @"5ffaa92f34a14a76b6b4927a223a7580";     // pre-assigned by service
NSString *kClientSecret = @"e3f8308508574b638ad1e5de3111bfa4"; // pre-assigned by service
NSString *kKeychainItemName = @"instagramKey";

- (id)initWithWindow:(NSWindow *)window
{
    self = [super initWithWindow:window];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (void)dealloc
{
    [super dealloc];
}

- (void)windowDidLoad
{
    [super windowDidLoad];
    
    AuthenticateDelegate *myDelegate = [[AuthenticateDelegate alloc] init];
    [web setFrameLoadDelegate: myDelegate];
    
    // Implement this method to handle any initialization after your window controller's window has been loaded from its nib file.
    
    // SHOW THE AUTHENTICATION URL
    NSURL *url = [NSURL URLWithString:@"https://instagram.com/oauth/authorize/?client_id=ab8ff1dcfca94aaabf7ac243883752a9&redirect_uri=http://www.amanata.com/photoplank/instagram/&response_type=token"];
    
    
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    [[web mainFrame] loadRequest:request];
    
    // GOGO GOOGLE VERSION OF IT!
    // [self signInToCustomService];
    
}

/* - (GTMOAuth2Authentication *)myCustomAuth {
    
    NSURL *tokenURL = [NSURL URLWithString:@"https://instagram.com/oauth/"];
    
    // We'll make up an arbitrary redirectURI.  The controller will watch for
    // the server to redirect the web view to this URI, but this URI will not be
    // loaded, so it need not be for any actual web page.
    NSString *redirectURI = @"http://www.google.com/OAuthCallback";
    
    GTMOAuth2Authentication *auth;
    auth = [GTMOAuth2Authentication authenticationWithServiceProvider:@"Instagram API"
                                                             tokenURL:tokenURL
                                                          redirectURI:redirectURI
                                                             clientID:kClientID
                                                         clientSecret:kClientSecret];
    return auth;
}

- (void)signInToCustomService {
    // [self signOut];
    
    GTMOAuth2Authentication *auth = [self myCustomAuth];
    
    // Specify the appropriate scope string, if any, according to the service's API documentation
    auth.scope = @"basic";
    
    // NSURL *authURL = [NSURL URLWithString:@"https://instagram.com/oauth/authorize"];
    
    // Display the authentication view
    GTMOAuth2WindowController *windowController;
    windowController = [[[GTMOAuth2WindowController alloc] initWithScope:auth.scope
                                                                clientID:kClientID
                                                            clientSecret:kClientSecret
                                                        keychainItemName:kKeychainItemName
                                                          resourceBundle:nil] autorelease];
    
    
    
    
    [self signInSheetModalForWindow:currentWindow
                                 delegate:self
                         finishedSelector:@selector(windowController:finishedWithAuth:error:)];
     
}*/

- (void)viewController:(GTMOAuth2WindowController *)viewController
      finishedWithAuth:(GTMOAuth2Authentication *)auth
                 error:(NSError *)error {
    if (error != nil) {
        // Sign-in failed
    } else {
        // Sign-in succeeded
    }
}

@end
