#import <Cocoa/Cocoa.h>
#import "AuthenticateWindowController.h"
#import "MainViewController.h"

@interface BackpackAppDelegate : NSObject <NSApplicationDelegate> {

@public
    NSString *tempUserToken;
    BOOL saveUserToken;

@private
    NSWindow *window;
    AuthenticateWindowController *myWindowController;
    MainViewController *mainViewController;
    
}

@property (retain, nonatomic) IBOutlet NSWindow *window;
@property (nonatomic) BOOL saveUserToken;
@property (retain) NSString *tempUserToken;

- (void)setMainViewController:(MainViewController*)vc;

- (void)openAuthWindow;
- (void)openMainView;

// global controls
- (IBAction)logoutCurrentUser:(id)sender;

@end
